import sensors, nidaq

from soar.graphing import *
import pickle

runLength = 100
makeGraph = True

def setup():
    robot.step = 0
    robot.D = []

def step():
    l, r = sensors.getLR()
    # l,r holds the distance to the left and right walls in meters
    # edit the lines below with your controller
    speed = 0.1
    angularVelocity = 0
    
    motorOutput(speed, angularVelocity)

    if makeGraph:
        # Gather data and make a graph at the end
        robot.D.append(l)
        robot.step += 1
        if robot.step == runLength:
            (minVal, maxVal) = (min(robot.D), max(robot.D))
            rangeIncr = (maxVal - minVal)*0.05
            g = GraphingWindow(500, 300, 0, runLength,
                               minVal-rangeIncr, maxVal+rangeIncr, "data")
            # Graph the data values as a function of their indices
            g.graphDiscrete(lambda x: robot.D[x])

            # Save the data into a file
            f = open("leftValues.py", "w")
            pickle.dump(robot.D, f)
            f.close()
            robot.step = 0
