import math

sensorPoses = [(0.1,  0.175, 1.571),
               (0.17, 0.15,  1.13),
               (0.2,  0.11,  0.698),
               (0.225, 0.05, 0.262),
               (0.225, -0.05, -0.262),
               (0.2,  -0.11, -0.698),
               (0.17, -0.15, -1.13),
               (0.1, -0.175, -1.571)]

sensorMax = 1.5

def getLR(sensorValues):
    print sensorValues[0], sensorValues[1], sensorValues[6], sensorValues[7]
    hits = []
    for ((sx,sy,sth), d) in zip(sensorPoses, sensorValues):
        if d < sensorMax:
            hits.append((sx + d*math.cos(sth),
                         sy + d*math.sin(sth)))
        else:
            hits.append(None)
    L = dist(hits[0], hits[1])
    R = dist(hits[6], hits[7])
    return (L, R)

def dist(h0, h1):
    print 'h0', h0, 'h1', h1
    if h0 and h1:
        (linex, liney, lined) = line(h0, h1)
        return abs(lined)
    elif h0:
        (hx, hy) = h0
        return math.sqrt(hx*hx + hy*hy)
    elif h1:
        (hx, hy) = h1
        return math.sqrt(hx*hx + hy*hy)
    else:
        return sensorMax
    
def line(h0, h1):
#    print h0, h1
    (h0x, h0y) = h0
    (h1x, h1y) = h1
    dx = h1x - h0x
    dy = h1y - h0y
    mag = math.sqrt(dx*dx + dy*dy)
    nx = dy/mag
    ny = -dx/mag
    d = (nx*h0x + ny*h0y)
#    print nx, ny, d
    return (nx, ny, d)
