from soar.graphing import *

import soar.outputs
import soar.outputs.simulator

dDesired = 0.5
k = 2.0  # You'll want to change this
runLength = 100
makeGraph = True

def setup():
    # Crank up the speed limit!!!
    soar.outputs.simulator.MAX_ROT = 100
    soar.outputs.simulator.MAX_TRANS = 100

    robot.step = 0
    robot.D = []

def step():
    d = min(sonarDistances()[3:5])
    v = 0.1       # Change the velocity here.
    print d, v
    motorOutput(v, 0)

    if makeGraph:
        # Gather data and make a graph at the end
        robot.D.append(d)
        robot.step += 1
        if robot.step == runLength:
            (minVal, maxVal) = (min(robot.D), max(robot.D))
            rangeIncr = (maxVal - minVal)*0.05
            g = GraphingWindow(500, 300, 0, runLength,
                               minVal-rangeIncr, maxVal+rangeIncr, "data")
            # Graph the data values as a function of their indices
            g.graphDiscrete(lambda x: robot.D[x])



        

    
    
